/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CAIXA                                                    */
/* Tabela : CAIXA                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 29/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CAIXA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CAIXA
GO

CREATE TRIGGER DTULTATU_CAIXA
ON CAIXA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CAIXA', CDFILIAL, 'CDFILIAL='+ CDFILIAL+ ';'+ 'CDCAIXA='+ CDCAIXA+ ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CAIXA
      SET DTULTATUCAIX = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(CAIXA.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0))
         AND (ISNULL(CAIXA.CDCAIXA,0) = ISNULL(INSERTED.CDCAIXA,0))

      UPDATE CONFTELA SET DTULTATUCFTE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE  CONFTELA.CDFILIAL   = INSERTED.CDFILIAL
        AND  CONFTELA.NRCONFTELA = INSERTED.NRCONFTELA;

      UPDATE ITMENUCONFTE SET DTULTATUITCT = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE  ITMENUCONFTE.CDFILIAL   = INSERTED.CDFILIAL
        AND  ITMENUCONFTE.NRCONFTELA = INSERTED.NRCONFTELA;

      UPDATE GRUPPROD SET DTULTATUGPPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE  GRUPPROD.CDGRUPPROD = INSERTED.CDGRUPPROD;

      UPDATE PRSUBGRPROD SET DTULTATUPRSUBGR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE  PRSUBGRPROD.CDGRUPPROD = INSERTED.CDGRUPPROD;

      UPDATE IMPRESSORA SET DTULTATUIMPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE  IMPRESSORA.CDIMPRESSORA = INSERTED.CDIMPRESSORA;

      UPDATE IMPRESSOOPER SET DTULTATUIMOP = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE  IMPRESSOOPER.CDIMPRESSORA = INSERTED.CDIMPRESSORA;
   END;
END;
GO

UPDATE CAIXA SET DTULTATUCAIX = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUCAIX IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUCAIX' and
            type = 'D')
   ALTER TABLE CAIXA DROP CONSTRAINT DEFAULT_DTULTATUCAIX

   ALTER TABLE CAIXA ADD CONSTRAINT DEFAULT_DTULTATUCAIX
   DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
   FOR DTULTATUCAIX
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CAIXA','4.11.194';
GO

