package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ElaboracaoCardapioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.ElaboraCardapioPage;
import org.testng.Assert;
import org.testng.annotations.Test;
import sun.awt.windows.ThemeReader;

public class ElaboracaoCardapioTests extends TestBase {
    ElaboraCardapioPage elaboracaocardapiopage;
    ElaboracaoCardapioFlows elaboracaoFlows;
    LoginFlows loginFlows;

    @Test
    public void elaboraCardapio() {

        elaboracaocardapiopage = new ElaboraCardapioPage();
        elaboracaoFlows = new ElaboracaoCardapioFlows();
        loginFlows = new LoginFlows();

        String FILIAL = "9999";
        String CDSERVICO = "00001";
        String msg = "COMENSAIS";
        String DTREFERENCIA = "26/04/2023";
        String NMPRATO1 = "ARROZ TEMPEREADO";
        String NMPRATO2 = "FEIJOADA SIMPLES";
        String NMPRATO3 = "SALADA DE ACELGA";
        String CDPRATO = "000000003";
        String COMENSAISSEG = "5";
        String COMENSAISTER = "20";
        String COMENSAISQUA = "20";
        String COMENSAISQUI = "15";
        String COMENSAISSEX = "20";
        String COMENSAISSAB = "0";
        String COMENSAISDOM = "0";
        String COMENSAISFER = "0";

        String DTINI = "01/05/2023";
        String DTFIM = "31/05/2023";
        String CDSERVICODESTINO = "00002";

        // Dados importação cardápio dia
        String CDFILIAL = "0002";
        String CDSERVICOORIGEM = "00002";
        String DTINICIAL = "01/04/2024";
        String DTFINAL = "30/04/2024";
        String DTDESTINO = "01/04/2024";

        //Dados para Inverter Pratos
        String NMPRATO = "FEIJOADA SIMPLES";
        String NMPRATO01 = "SALADA";
        String DTINIPRTO = "01/04/2024";
        String DTFIMPRATO = "02/04/2024";

        loginFlows.efetuarLogin();
        elaboracaoFlows.NavegaElaboracaoCardapio();

        elaboracaocardapiopage.clicarCampoFilial();
        elaboracaocardapiopage.informaFilial(FILIAL);
        elaboracaoFlows.filtrarServico(CDSERVICO);
        elaboracaoFlows.mesCardapio();
        elaboracaoFlows.custoCardapioPlanejado();
        elaboracaoFlows.custoCardapioReal();
        elaboracaoFlows.dataReferencia(DTREFERENCIA);
        elaboracaoFlows.confirmaFiltroCardapio();
        Assert.assertTrue(elaboracaocardapiopage.mensagemEsperada().contains(msg));

        elaboracaoFlows.elaboraCardapio(NMPRATO1,NMPRATO2,NMPRATO3);
        elaboracaoFlows.analiseDeCorCardapio();
        elaboracaoFlows.analiseDeCustos();
        elaboracaoFlows.atualizaDataReferenciaCusto(CDSERVICO,DTREFERENCIA);
        elaboracaoFlows.atualizaDataRecalculoCusto(CDSERVICO);
        elaboracaoFlows.calcularNutrientes();
        elaboracaoFlows.copiaPratosComensais(CDPRATO,COMENSAISSEG,COMENSAISTER,COMENSAISQUA,COMENSAISQUI,COMENSAISSEX,COMENSAISSAB,COMENSAISDOM,COMENSAISFER);
        elaboracaoFlows.copiarComensais(CDPRATO);
        elaboracaoFlows.exportaCardapio(DTINI, DTFIM,CDSERVICODESTINO);
        elaboracaoFlows.importaCardapioDia(FILIAL,CDSERVICO, CDSERVICOORIGEM,DTINICIAL, DTFINAL, DTDESTINO);
        elaboracaoFlows.importarTipoDePrato(CDFILIAL,CDSERVICOORIGEM, DTINICIAL);
        elaboracaoFlows.excluirCardapioPeriodo(DTINICIAL, DTFINAL);
        elaboracaoFlows.inverterPratosDia(NMPRATO, NMPRATO01,DTINIPRTO,DTFIMPRATO);
        elaboracaoFlows.revisaoReceitaLocal();
        elaboracaoFlows.revisaoDeReceitaPorServico();
        elaboracaoFlows.informacaoNutricionaoPrato();
        elaboracaoFlows.exportaCardapioSobrepondo(CDSERVICODESTINO);
        elaboracaoFlows.excluirCardapioPeriodo(DTINICIAL, DTFINAL);
        elaboracaoFlows.excluirPratoDia();
        elaboracaoFlows.excluirCardapioPeriodo(DTINICIAL, DTFINAL);
        elaboracaoFlows.configurarCardapio();

    }

}
