package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.EmbalagemFlows;
import com.javaseleniumtemplate.pages.EmbalagemPage;

import org.testng.annotations.Test;

public class EmbalagemTests extends TestBase {

    EmbalagemPage embalagemPage;
    EmbalagemFlows embalagemFlows;
    LoginFlows loginFlows;

    //tentar adicionar uma embalagem com um código já existente
    //adicionar, editar e excluir uma embalagem
    //tentar excluir uma embalagem que possuí registros filhos
    @Test
    public void embalagem() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.adicionarCodigoExistente();
        embalagemPage.refresh();
        embalagemPage.adicionar(true);
        embalagemPage.editar();
        embalagemPage.excluir();
        embalagemPage.tentarExcluirEmbaComRegistrosFilhos();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //verificar os campos obrigatórios da tela de adicionar embalagem
    //verificar as opções presentes nos campos 'tipo' e 'porpósito' da tela de adicionar embalagem
    @Test
    public void verificarCamposTelaAdicionarEmbalagem() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.camposObrigatorios();
        embalagemPage.refresh();
        embalagemPage.verificarOpcaoesTipoEProposito();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //adicionar uma embalagem com o campos capacidade preenchido e zera o mesmo por meio do inLine
    //excluir a embalagem adicionada que foi zerada pelo inLine
    //adicionar uma embalagem com o campo capacidade vazio e excluir a mesma
    @Test
    public void embalagemComCapacidadeVazia() {
        embalagemPage = new EmbalagemPage();
        embalagemFlows = new EmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        embalagemFlows.navegateEmbalagem();
        embalagemPage.adicionar(true);
        embalagemPage.zerarCapacidadePeloInLine();
        embalagemPage.excluir();
        embalagemPage.adicionar(false);
        embalagemPage.editarCapacidadepeloInLine();
        embalagemPage.excluir();


        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}
